/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the GroupInfo type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GroupInfo{}

// GroupInfo struct for GroupInfo
type GroupInfo struct {
	Id              NullableString `json:"id,omitempty"`
	GroupIdentifier NullableString `json:"groupIdentifier,omitempty"`
	DisplayName     NullableString `json:"displayName,omitempty"`
	Description     NullableString `json:"description,omitempty"`
}

// NewGroupInfo instantiates a new GroupInfo object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGroupInfo() *GroupInfo {
	this := GroupInfo{}
	return &this
}

// NewGroupInfoWithDefaults instantiates a new GroupInfo object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGroupInfoWithDefaults() *GroupInfo {
	this := GroupInfo{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GroupInfo) GetId() string {
	if o == nil || IsNil(o.Id.Get()) {
		var ret string
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GroupInfo) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *GroupInfo) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableString and assigns it to the Id field.
func (o *GroupInfo) SetId(v string) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *GroupInfo) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *GroupInfo) UnsetId() {
	o.Id.Unset()
}

// GetGroupIdentifier returns the GroupIdentifier field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GroupInfo) GetGroupIdentifier() string {
	if o == nil || IsNil(o.GroupIdentifier.Get()) {
		var ret string
		return ret
	}
	return *o.GroupIdentifier.Get()
}

// GetGroupIdentifierOk returns a tuple with the GroupIdentifier field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GroupInfo) GetGroupIdentifierOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.GroupIdentifier.Get(), o.GroupIdentifier.IsSet()
}

// HasGroupIdentifier returns a boolean if a field has been set.
func (o *GroupInfo) HasGroupIdentifier() bool {
	if o != nil && o.GroupIdentifier.IsSet() {
		return true
	}

	return false
}

// SetGroupIdentifier gets a reference to the given NullableString and assigns it to the GroupIdentifier field.
func (o *GroupInfo) SetGroupIdentifier(v string) {
	o.GroupIdentifier.Set(&v)
}

// SetGroupIdentifierNil sets the value for GroupIdentifier to be an explicit nil
func (o *GroupInfo) SetGroupIdentifierNil() {
	o.GroupIdentifier.Set(nil)
}

// UnsetGroupIdentifier ensures that no value is present for GroupIdentifier, not even an explicit nil
func (o *GroupInfo) UnsetGroupIdentifier() {
	o.GroupIdentifier.Unset()
}

// GetDisplayName returns the DisplayName field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GroupInfo) GetDisplayName() string {
	if o == nil || IsNil(o.DisplayName.Get()) {
		var ret string
		return ret
	}
	return *o.DisplayName.Get()
}

// GetDisplayNameOk returns a tuple with the DisplayName field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GroupInfo) GetDisplayNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.DisplayName.Get(), o.DisplayName.IsSet()
}

// HasDisplayName returns a boolean if a field has been set.
func (o *GroupInfo) HasDisplayName() bool {
	if o != nil && o.DisplayName.IsSet() {
		return true
	}

	return false
}

// SetDisplayName gets a reference to the given NullableString and assigns it to the DisplayName field.
func (o *GroupInfo) SetDisplayName(v string) {
	o.DisplayName.Set(&v)
}

// SetDisplayNameNil sets the value for DisplayName to be an explicit nil
func (o *GroupInfo) SetDisplayNameNil() {
	o.DisplayName.Set(nil)
}

// UnsetDisplayName ensures that no value is present for DisplayName, not even an explicit nil
func (o *GroupInfo) UnsetDisplayName() {
	o.DisplayName.Unset()
}

// GetDescription returns the Description field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GroupInfo) GetDescription() string {
	if o == nil || IsNil(o.Description.Get()) {
		var ret string
		return ret
	}
	return *o.Description.Get()
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GroupInfo) GetDescriptionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Description.Get(), o.Description.IsSet()
}

// HasDescription returns a boolean if a field has been set.
func (o *GroupInfo) HasDescription() bool {
	if o != nil && o.Description.IsSet() {
		return true
	}

	return false
}

// SetDescription gets a reference to the given NullableString and assigns it to the Description field.
func (o *GroupInfo) SetDescription(v string) {
	o.Description.Set(&v)
}

// SetDescriptionNil sets the value for Description to be an explicit nil
func (o *GroupInfo) SetDescriptionNil() {
	o.Description.Set(nil)
}

// UnsetDescription ensures that no value is present for Description, not even an explicit nil
func (o *GroupInfo) UnsetDescription() {
	o.Description.Unset()
}

func (o GroupInfo) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GroupInfo) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if o.GroupIdentifier.IsSet() {
		toSerialize["groupIdentifier"] = o.GroupIdentifier.Get()
	}
	if o.DisplayName.IsSet() {
		toSerialize["displayName"] = o.DisplayName.Get()
	}
	if o.Description.IsSet() {
		toSerialize["description"] = o.Description.Get()
	}
	return toSerialize, nil
}

type NullableGroupInfo struct {
	value *GroupInfo
	isSet bool
}

func (v NullableGroupInfo) Get() *GroupInfo {
	return v.value
}

func (v *NullableGroupInfo) Set(val *GroupInfo) {
	v.value = val
	v.isSet = true
}

func (v NullableGroupInfo) IsSet() bool {
	return v.isSet
}

func (v *NullableGroupInfo) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGroupInfo(val *GroupInfo) *NullableGroupInfo {
	return &NullableGroupInfo{value: val, isSet: true}
}

func (v NullableGroupInfo) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGroupInfo) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
